﻿//const { debug } = require("webpack");

var Side = function(data) {
    var _ = this;

    //debugger;
    //window.sideData = data;
    //console.log(data);

    var propertyHTML = '';
    Object.keys(data.goods.property).forEach(item => {
        propertyHTML += `<div style="display: flex">
            <div style="color: #747474; width: 65px; flex-shrink: 0;">${item}</div
            ><span style="font-weight: bold; width: 110px; word-break: break-all;">${data.goods.property[item]}</span> </div
        >`;
    });

    var originPropertyHTML = '';
    var originPropertyStyle = 'display:none;';
    if (data.goods.originProperty) {
        Object.keys(data.goods.originProperty).forEach(item => {
            originPropertyStyle = '';
            originPropertyHTML += `<div style="display: flex">
                <div style="color: #747474; width: 65px; flex-shrink: 0;">${item}</div
                ><span style="font-weight: bold">${data.goods.originProperty[item]}</span> </div
            >`;
        });
    }

    var orderHTML = '';
    data.order.orders.forEach(item => {
        orderHTML += `<div style="display: flex; margin-bottom: 5px;"
            ><img src="${item.icon}" style="width: 17px; object-fit: contain; margin-right: 10px;"/>
            <div class='orderHTML' style="color: #747474; margin-right: 10px; margin-top: 3px;"
                >${item.sn}</div
            ></div
        >`;
    });

    this.show = function() {
        var HTML = `<div
                class="wxwPurchaseBox"
                style="
                    z-index:9999999;
                    font-family:Helvetica Neue,Helvetica,PingFang SC,Hiragino Sans GB,Microsoft YaHei,SimSun,sans-serif;
                    position: fixed;
                    right: 50px;
                    top: 50px;
                    width: 300px;
                    background-color: #fff;
                    box-shadow: 0 2px 12px 0 rgb(0 0 0 / 20%);
                    z-index: 100000000;
                    padding: 8px 14px;
                    box-sizing: border-box;
                    font-size: 12px;
                "
            >
                <div 
                    class="wxwPurchaseShade" 
                    style="
                        position: absolute;
                        left: 0;
                        right: 0;
                        top: 0;
                        bottom: 0;
                        background: #fff;
                        opacity: 0.5;
                        display: none;
                    ">
                </div>
                <div class="ui-side-caption" style="margin-bottom: 20px; position: relative; color: #fff;">
                    <div style="
                        position: absolute;
                        background-color: #409FEE;
                        left: -14px;
                        right: -14px;
                        top: -8px;
                        bottom: -8px;
                        z-index: -1;
                    "></div>
                    商品信息
                    <div style="float: right">
                        <span class="wxwPurchaseQrcodeBtn" style="margin-right: 9px; cursor: pointer">
                            <i class="icon-qrcode" style="margin-right: 2px"></i>
                            手机下单 </span
                        ><i class="wxwPurchaseCloseBtn icon-remove" style="cursor: pointer"></i>
                        <div> </div> </div
                ></div>
                <div style="display: flex; flex-direction: row; margin-bottom: 15px">
                    <div
                        style="
                            width: 90px;
                            flex-shrink: 0;
                            display: flex;
                            flex-direction: column;
                            align-items: center;
                            margin-right: 16px;
                        "
                        data-spm-anchor-id="2013.1.0.i0.1a43574eOiO4hT"
                    >
                        <img
                            src="${data.goods.pic}"
                            style="
                                vertical-align: middle;
                                width: 90px;
                                border: 1px solid #e0e0e0;
                                margin-bottom: 5px;
                            "
                        />
                        <div
                            class="wxwPurchaseSearchBtn"
                            style="color: #747474; cursor: pointer"
                            data-spm-anchor-id="2013.1.0.i0.1a43574eqbSkTL"
                            >查找同款商品</div
                        >
                    </div>
                    <div style="width: 100%">
                        <div style="margin-bottom: 15px; width: 120px; word-break: break-all;">${data.goods.goodsSkuCode}</div>
                        <div style="margin-bottom: 15px"
                            ><div style="font-weight: bold; margin-bottom: 5px"
                                >规格</div
                            >
                            <div>${propertyHTML}</div>
                        </div>
                        <div style="margin-bottom: 15px;${originPropertyStyle}"
                            ><div style="font-weight: bold; margin-bottom: 5px"
                                >采集源规格</div
                            >
                            <div style="margin-bottom: 7px">${originPropertyHTML}</div>
                            <div
                                ><div
                                    class="wxwPurchaseCheckedBtn"
                                    style="
                                        display: inline-block;
                                        color: rgb(255, 255, 255);
                                        cursor: pointer;
                                        font-size: 12px;
                                        font-weight: 700;
                                        background: rgb(64, 159, 238);
                                        border-radius: 3px;
                                        padding: 5px 10px;
                                    "
                                    >自动选中规格</div
                                ></div
                            ></div
                        >
                        <div style="font-weight: bold; margin-bottom: 5px"
                            >采购数量</div
                        >
                        <div style="color: red"
                            ><span style="font-size: 18px; margin-right: 5px">${data.goods.qty}</span
                            ><span>件</span></div
                        >
                    </div> </div
                ><div style="margin-bottom: 20px; position: relative; color: #fff;">
                    <div style="
                        position: absolute;
                        background-color: #409FEE;
                        left: -14px;
                        right: -14px;
                        top: -8px;
                        bottom: -8px;
                        z-index: -1;
                    "></div>
                    订单信息
                </div>
                <div class="ui-side-caption" style="margin-bottom: 20px">
                    <div style="display: flex; margin-bottom: 15px">
                        <div style="font-weight: bold; width: 106px; flex-shrink: 0"
                            >订单编号</div
                        >
                        <div>${orderHTML}</div>
                    </div>
                    <div style="display: flex">
                        <div style="display: flex; width: 106px; flex-shrink: 0"
                            ><span style="font-weight: bold"
                                >收件地址<i
                                    class="wxwPurchaseCopyBtn icon-copy"
                                    style="margin-left: 3px; cursor: pointer"
                                    data-spm-anchor-id="2013.1.0.i1.1a43574eqbSkTL"
                                ></i></span
                        ></div>
                        <div>
                            <div style="margin-bottom: 5px">${data.order.address.name}</div>
                            <div style="margin-bottom: 5px"
                                >${data.order.address.province} ${data.order.address.city} ${data.order.address.area} ${data.order.address.street}</div
                            >
                            <div style="margin-bottom: 5px"
                                >${data.order.address.address}</div
                            >
                            <div style="margin-bottom: 7px">${data.order.address.tel}</div>
                            <div
                                class="wxwPurchaseWriteBtn"
                                style="
                                    display: inline-block;
                                    color: rgb(255, 255, 255);
                                    cursor: pointer;
                                    font-size: 12px;
                                    font-weight: 700;
                                    background: rgb(64, 159, 238);
                                    border-radius: 3px;
                                    padding: 5px 10px;
                                "
                                >自动填写地址</div
                            >
                        </div>
                    </div>
                </div>
                <div class="ui-side-caption" style="margin-bottom: 20px; position: relative; color: #fff;">
                    <div style="
                        position: absolute;
                        background-color: #409FEE;
                        left: -14px;
                        right: -14px;
                        top: -8px;
                        bottom: -8px;
                        z-index: -1;
                    "></div>    
                    其他信息
                </div>
                <div style="margin-bottom: 10px">
                    <div style="display: flex; margin-bottom: 15px;">
                        <div style="font-weight: bold; width: 106px; flex-shrink: 0"
                            >商家备注</div
                        >
                        <div style="color: #747474;">${data.order.memo.seller}</div>
                    </div>
                    <div style="display: flex; margin-bottom: 15px">
                        <div style="font-weight: bold; width: 106px; flex-shrink: 0"
                            >商家备注</div
                        >
                        <div style="color: #747474;">${data.order.memo.buyer}</div>
                    </div>
                    <div style="display: flex">
                        <div style="font-weight: bold; width: 106px; flex-shrink: 0"
                            >拣货备注</div
                        >
                        <div style="color: #747474;">${data.order.memo.pickup}</div>
                    </div>
                </div>
            </div>`;

        $('.btnButton').hide();
        $('body').append(HTML);
        $('body').on('click', '.wxwPurchaseQrcodeBtn', function() {
            let qrcodeHTML = `
                    <div
                        class="wxwQrcode"
                        style="
                            right: 86px;
                            top: 86px;
                            position: fixed;
                            background-color: #fff;
                            box-shadow: 0 2px 12px 0 rgb(0 0 0 / 20%);
                            z-index: 100000000;
                            width: 228px;
                            height: 258px;
                            box-sizing: border-box;
                            padding: 8px 14px 14px 14px;
                            font-size: 12px;
                        "
                        ><div
                            style="
                                display: flex;
                                justify-content: space-between;
                                align-items: center;
                                margin-bottom: 22px;
                                position: relative; 
                                color: #fff;
                            "
                            >
                            <div style="
                                position: absolute;
                                background-color: #409FEE;
                                left: -14px;
                                right: -14px;
                                top: -8px;
                                bottom: -8px;
                                z-index: -1;
                            "></div>
                            <span>请扫码</span>
                            <i class="wxwQrcodeCloseBtn icon-remove" style="cursor: pointer"></i
                        ></div>
                        <img
                            src="${data.order.qrcodeImageUrl}"
                            style="width: 100%"
                        />
                    </div>`;
            $('body').append(qrcodeHTML);
            $('body').on('click', '.wxwQrcodeCloseBtn', function() {
                $('.wxwQrcode').css('display', 'none');
                $('body')
                    .find('.wxwPurchaseShade')
                    .css('display', 'none');
            });
            $('body')
                .find('.wxwPurchaseShade')
                .css('display', 'block');
        });
        $('body').on('click', '.wxwPurchaseCloseBtn', function() {
            $('.wxwPurchaseBox').css('display', 'none');
        });
        $('body').on('mouseover mouseout', '.wxwPurchaseSearchBtn', function(
            event
        ) {
            if (event.type == 'mouseover') $(this).css('color', '#409FEE');
            else if (event.type == 'mouseout') $(this).css('color', '#747474');
        });
        $('body').on(
            'mouseover mouseout click',
            '.wxwPurchaseCopyBtn',
            function(event) {
                if (event.type == 'mouseover') $(this).css('color', '#409FEE');
                else if (event.type == 'mouseout') $(this).css('color', '#000');
                else {
                    navigator.clipboard.writeText(
                        `${data.order.address.province} ${data.order.address.city} ${data.order.address.area} ${data.order.address.street} ${data.order.address.address}\n${data.order.address.tel}\n${data.order.address.name}\n`
                    );

                    __ui.showMessage({
                        success: true,
                        message: getI18n('复制地址成功'),
                    });
                }
            }
        );

        var obj = eval(data.injectCode);

        $('body').on(
            'mouseover mouseout click',
            '.wxwPurchaseCheckedBtn',
            function(event) {
                if (event.type == 'mouseover')
                    $(this).css('background-color', '#55ACF4');
                else if (event.type == 'mouseout')
                    $(this).css('background-color', '#409FEE');
                else {
                    if (!obj || !obj.selectSkus) {
                        __ui.showMessage({
                            success: false,
                            message: getI18n('暂不支持选择规格'),
                        });
                        return;
                    }

                    var result = obj.selectSkus(data.goods.originProperty);

                    if (result) __ui.showMessage(result);
                }
            }
        );
        $('body').on(
            'mouseover mouseout click',
            '.wxwPurchaseWriteBtn',
            function(event) {
                if (event.type == 'mouseover')
                    $(this).css('background-color', '#55ACF4');
                else if (event.type == 'mouseout')
                    $(this).css('background-color', '#409FEE');
                else {
                    if (!obj || !obj.selectAddress) {
                        debugger;
                        __ui.showMessage({
                            success: false,
                            message: getI18n('暂不支持自动选择地址'),
                        });
                        return;
                    }

                    var result = obj.selectAddress(data.order.address);

                    if (result) __ui.showMessage(result);
                }
            }
        );
        $('.orderHTML').on('mouseover mouseout click', function(event) {
            if (event.type == 'mouseover') {
                $(this).css('text-decoration', 'underline ');
                $(this).css('cursor', 'pointer ');
            } else if (event.type == 'mouseout') {
                $(this).css('text-decoration', 'none ');
                $(this).css('cursor', 'none ');
            } else {
                let message = $(this).text();
                navigator.clipboard
                    .writeText(message)
                    .then(() => {
                        __ui.showMessage({
                            success: true,
                            message: getI18n('复制成功'),
                        });
                        return;
                    })
                    .catch(error => {
                        __ui.showMessage({
                            success: false,
                            message: getI18n('复制失败'),
                        });
                        return;
                    });
            }
        });
    };
};
